/*============================================================================*
 *  FILE: 
 *     msgmgr.c
 *
 *  Description: 
 *     Message(Thread) manager for NNsh. 
 *
 *===========================================================================*/
#define MSGMGR_C
#include "local.h"
extern UInt32 CreateThreadIndexSub_ARM();

/*=========================================================================*/
/*   Function : CreateThreadIndexSub                                       */
/*                                              (CfbNX擾̎) */
/*=========================================================================*/
static Err createThreadIndexSub(Char   *buffer, UInt32 size, UInt32 offset,
                                UInt32 *nofMsg, UInt32 *msgOffset)
{
    Char *chkPtr, *ptr;
    
    chkPtr = buffer;
    while (chkPtr < buffer + size)
    {
        // bZ[W̋؂T
        ptr = chkPtr;
        while ((*ptr != '\x0a')&&(*ptr != '\0'))
        {
            ptr++;
        }
        if (*ptr != '\0')
        {
            ptr = ptr + 1;
            if (*nofMsg < NNSH_MESSAGE_MAXNUMBER)
            {
                (*nofMsg)++;
                msgOffset[(*nofMsg)] = (UInt32) ptr - (UInt32) buffer + offset;
                chkPtr = ptr;
            }
            else
            {
                return (~errNone - 1);
            }
        }
        else
        {
            // Ƃ肠ɂ
            chkPtr = ptr + 1;
        }
    }
    return (errNone);
}

/*=========================================================================*/
/*   Function : get_subject_database                                       */
/*                                                         X擾  */
/*=========================================================================*/
Err Get_Subject_Database(UInt16 index, NNshSubjectDatabase *subjDB)
{
    Err       ret;
    DmOpenRef dbRef;

    // XǗDBI[v
    OpenDatabase_NNsh(DBNAME_SUBJECT, DBVERSION_SUBJECT, &dbRef);
    if (dbRef == 0)
    {
        // G[(fobO\)
        NNsh_DebugMessage(ALTID_INFO, "ERR>OpenDatabase_NNsh() ", " ", 0);
        return (~errNone);
    }

    // Xf[^擾
    ret = GetRecord_NNsh(dbRef, index, sizeof(NNshSubjectDatabase), subjDB);
    if (ret != errNone)
    {
        // G[(fobO\)
        NNsh_DebugMessage(ALTID_INFO, "ERR>GetRecord_NNsh() ", " ", ret);
    }
    CloseDatabase_NNsh(dbRef);
    return (ret);
}

/*=========================================================================*/
/*   Function : MoveMessageToReadOnly                                      */
/*                                  (bZ[WQƐpXɈړ) */
/*=========================================================================*/
Err MoveMessageToReadOnly(UInt16 index)
{
    Err                 ret;
    NNshSubjectDatabase subjDb;

    ////////////////////  f[^x[X̏XXV  ////////////////////

    // ̈̏
    MemSet(&subjDb, sizeof(subjDb), 0x00);

    // f[^x[Xf[^擾
    ret = Get_Subject_Database(index, &subjDb);
    if (ret != errNone)
    {
        // 肦Ȃ͂H
        NNsh_DebugMessage(ALTID_INFO, "get_subject_database()"," ", ret);
        return (ret);
    }

    // Xuǂ݂ݐpvɍXV
    MemSet (subjDb.boardNick, MAX_NICKNAME, 0x00);
    StrCopy(subjDb.boardNick, OFFLINE_THREAD_NICK);

    // f[^XV
    ret = update_subject_database(index, &subjDb);
    if (ret != errNone)
    {
        // 肦Ȃ͂...
        NNsh_DebugMessage(ALTID_INFO, "update_subject_database()"," ", ret);
        return (ret);
    }
    return (errNone);
}

/*-------------------------------------------------------------------------*/
/*   Function : createThreadIndexSub_MachiBBS                              */
/*                            (CfbNX擾̎:܂BBSp`[) */
/*-------------------------------------------------------------------------*/
static Err createThreadIndexSub_MachiBBS(Char   *buffer, UInt32 size,
    UInt32 offset, UInt32 *nofMsg, UInt32 *msgOffset, Char *start, Char *end)
                                
{
    Char *chkPtr, *ptr;
    
    chkPtr = buffer;

    // 擪ǂݏoƂAbZ[W̐擪肷
    if (*nofMsg == 0)
    {
        ptr = StrStr(chkPtr, start);
	if (ptr == NULL)
        {
            // ؂肪ȂA͏I(G[)
	  NNsh_DebugMessage(ALTID_ERROR, "Not Found Message Top :", start, 0);
            return (~errNone - 2);
        }
        ptr = ptr + StrLen(start);
        msgOffset[0] = ((UInt32) (ptr - buffer)) + offset;
        chkPtr = ptr;
        NNsh_DebugMessage(ALTID_INFO, "FIND MESSAGE TOP :", "", msgOffset[0]);
    }
    while (chkPtr < buffer + size)
    {
        // bZ[W̋؂T
        ptr = StrStr(chkPtr, end);
        if (ptr == NULL)
        {
            // ؂肪ȂA͏I
            break;
        }
        ptr = ptr + StrLen(end);
        if (*nofMsg < NNSH_MESSAGE_MAXNUMBER)
        {
            (*nofMsg)++;
            msgOffset[(*nofMsg)] = (UInt32) ptr - (UInt32) buffer + offset;
            chkPtr = ptr;
        }
        else
        {
            // bZ[W̊i[\ȍő吔𒴂(I[ot[\)
            NNsh_InformMessage(ALTID_WARN, "Index Number overflow", "", 0);
            return (~errNone - 1);
        }
    }
    NNsh_DebugMessage(ALTID_INFO, "Parsed Token :", "", *nofMsg);
    return (errNone);
}

/*=========================================================================*/
/*   Function : createMessageThreadIndex                                   */
/*                                (bZ[WXbh̃CfbNX쐬)   */
/*=========================================================================*/
Err CreateMessageThreadIndex(NNshMessageIndex *index, UInt32 *nofMsg,
                             UInt32 *msgOffset, UInt16 bbsType)
{
    Err          ret = errNone;
    UInt32       fileSize, readSize, chkPoint;
    Char        *bufPtr;
#ifdef USE_ARMLET
    UInt32       armArgs[6];
    MemHandle    armH;
    void        *armP;

    // ARMlet̊֐|C^擾
    armH = 0;
    armP = NULL;
    if (NNshParam->useARMlet != 0)
    {
        armH = DmGetResource('armc', RSCID_createThreadIndexSub_ARM);
        if (armH != 0)
        {
            armP = MemHandleLock(armH);
        }
    }
#endif

    // CfbNX쐬\
    Show_BusyForm(MSG_CREATE_MESSAGE_IDX);

    // ꎞIɓǂݍޗ̈̏
    bufPtr   = index->buffer;
    *nofMsg  = 0;
    fileSize = 0;
    while (fileSize < index->fileSize)
    {
        MemSet(bufPtr, NNshParam->bufferSize, 0x00);
        readSize = 0;
        ret      = ReadFile_NNsh(&(index->fileRef), fileSize,
                                 NNshParam->bufferSize, bufPtr, &readSize);
        switch (ret)
        {
            case vfsErrFileEOF:
            case fileErrEOF:
            case errNone:
              // read OK, create Index!
              break;

            default:
              // read failure!
              goto FUNC_END;
              break;
        }
        switch (bbsType)
        {
          case NNSH_BBSTYPE_MACHIBBS:
            //  ܂BBS/΁iaar̓g[N߁Ag[N
            // rŃobt@sƂ̑΍ꂽ()B
            if (ret == errNone)
            {
                chkPoint = readSize - sizeof(NNSH_MACHITOKEN_END) + 2;
            }
            else
            {
                chkPoint = readSize;
            }
            //  ܂BBS̃CfbNX͏(html)
            ret = createThreadIndexSub_MachiBBS(index->buffer, readSize,
                                                fileSize, nofMsg, msgOffset,
                                                NNSH_MACHITOKEN_START,
                                                NNSH_MACHITOKEN_END);
            readSize = chkPoint;
            break;

          case NNSH_BBSTYPE_SHITARABAJBBS:
            //  ܂BBS/΁iaar̓g[N߁Ag[N
            // rŃobt@sƂ̑΍ꂽ()B
            if (ret == errNone)
            {
                chkPoint = readSize - sizeof(NNSH_JBBSTOKEN_END) + 2;
            }
            else
            {
                chkPoint = readSize;
            }
            //  ܂BBS̃CfbNX͏(html)
            ret = createThreadIndexSub_MachiBBS(index->buffer, readSize,
                                                fileSize, nofMsg, msgOffset,
                                                NNSH_JBBSTOKEN_START,
                                                NNSH_JBBSTOKEN_END);
            readSize = chkPoint;
            break;

          case NNSH_BBSTYPE_2ch:
          case NNSH_BBSTYPE_SHITARABA:
          default:
            //  2˂/΂̃CfbNX͏(datǂ)
#ifdef USE_ARMLET
            if (armP != NULL)
            {
                // ARMletgpẴCfbNX͏
                MemSet(armArgs, sizeof(armArgs), 0x00);
                armArgs[0] = (UInt32) msgOffset;
                armArgs[1] = (UInt32) nofMsg;
                armArgs[2] = (UInt32) fileSize;
                armArgs[3] = (UInt32) readSize;
                armArgs[4] = (UInt32) index->buffer;
                ret        = (Err) PceNativeCall(armP, armArgs);
            }
            else
#endif
            {
                // ARMletgpȂꍇ̃CfbNX͏
                ret = createThreadIndexSub(index->buffer, readSize,
                                           fileSize, nofMsg, msgOffset);
            }
            break;
        }
        if (ret != errNone)
        {
            // CfbNXI[ot[(肦Ȃ͂...)Arł߂
            // bZ[W̊i[\ȍő吔𒴂(I[ot[\)
            NNsh_InformMessage(ALTID_WARN, "Index Number overflow", "", 0);

            // Ƃ肠ǂ߂悤ɂ(errNoneɒu)
            ret = errNone;
            break;
        }

        // ǂݍ݈ʒu fileSizeɐݒ肷B
        fileSize = fileSize + readSize;        
    }

FUNC_END:
#ifdef USE_ARMLET
    // ARMlet̊֐
    if (armP != NULL)
    {
        MemHandleUnlock(armH);
    }
    if (armH != 0)
    {
        DmReleaseResource(armH);
    }
#endif
    Hide_BusyForm(true);
    return (ret);
}

/*-------------------------------------------------------------------------*/
/*   Function : update_subject_database                                    */
/*                                                         XXV  */
/*-------------------------------------------------------------------------*/
Err update_subject_database(UInt16 index, NNshSubjectDatabase *subjDB)
{
    Err       ret;
    DmOpenRef dbRef;

    OpenDatabase_NNsh(DBNAME_SUBJECT, DBVERSION_SUBJECT, &dbRef);
    if (dbRef == 0)
    {
        // G[(fobO\)
        NNsh_DebugMessage(ALTID_INFO, "ERR>OpenDatabase_NNsh() ", " ", 0);
        return (~errNone);
    }

    // Xf[^XV
    ret = UpdateRecord_NNsh(dbRef,index,sizeof(NNshSubjectDatabase),subjDB);
    if (ret != errNone)
    {
        // G[(fobO\)
        NNsh_DebugMessage(ALTID_INFO, "ERR>GetRecord_NNsh() ", " ", ret);
    }
    CloseDatabase_NNsh(dbRef);

    // XꗗDBXVƂɂ
    NNshGlobal->updateDatabaseInfo = 
                ((NNshGlobal->updateDatabaseInfo) | (NNSH_DB_UPDATE_SUBJECT));

    return (ret);
}

/*-------------------------------------------------------------------------*/
/*   Function :   NNshMSG_entryDatabase                                    */
/*                                                bZ[WDBɓo^ */
/*-------------------------------------------------------------------------*/
static void message_entryDatabase(UInt16 idxMES,UInt32 fileSize,UInt16 bbsType)
{
    Err                 ret;
    NNshSubjectDatabase subjDb;

    // ̈̏
    MemSet(&subjDb, sizeof(subjDb), 0x00);

    if (idxMES != NNSH_NOTENTRY_THREAD)
    {
        // f[^x[Xf[^擾
        ret = Get_Subject_Database(idxMES, &subjDb);
        if (ret != errNone)
        {
            // 肦Ȃ͂H
            NNsh_DebugMessage(ALTID_INFO, "get_subject_database()"," ", ret);
            return;
        }
    }

    ///// DBɏރf[^쐬 /////

    // Ԓlق
    if (fileSize != 0)
    {
        subjDb.state        = NNSH_SUBJSTATUS_NEW;
        subjDb.currentLoc   = 1;
        subjDb.fileSize     = fileSize;
        subjDb.bbsType      = (UInt8) bbsType;
        subjDb.msgAttribute = (subjDb.msgAttribute & NNSH_MSGATTR_NOTERROR);

        // X̋L^o^
        if ((NNshParam->useVFS & NNSH_VFS_ENABLE) != 0)
        {
            // XL^VFS
            subjDb.msgState = FILEMGR_STATE_OPENED_VFS;
        }
        else
        {    
            // XL^Palm{
            subjDb.msgState = FILEMGR_STATE_OPENED_STREAM;
        }
    }
    else
    {
        subjDb.state      = NNSH_SUBJSTATUS_NOT_YET;
        subjDb.currentLoc = 0;
        subjDb.fileSize   = 0;
        subjDb.bbsType    = (UInt8) bbsType;
    }

    // f[^XV
    ret = update_subject_database(idxMES, &subjDb);
    if (ret != errNone)
    {
        // 肦Ȃ͂...
        NNsh_DebugMessage(ALTID_INFO, "update_subject_database()","",ret);
    }
    return;
}

/*-------------------------------------------------------------------------*/
/*   Function :   NNshMSG_entryMessage                                     */
/*                                                  bZ[WϊAo^ */
/*-------------------------------------------------------------------------*/
static Err message_entryMessage(Char *targetFile, UInt32 *dataSize, UInt16 bbsType)
{
    Err           ret;
    Boolean       deleteLogFile;
    UInt32        fileSize, offset, readSize, writeSize, chkSize;
    Char         *buffer, *ptr, *realBuf, *bakPtr;
    NNshFileRef  fileRefR, fileRefW;

    deleteLogFile = false;
    fileSize  = 0;
    offset    = 0;
    *dataSize = 0;

    // "bZ[Wϊ" \s
    Show_BusyForm(MSG_MESSAGE_ENTRY);

    // ǂݏot@C̃I[v
    ret = OpenFile_NNsh(FILE_RECVMSG,
                        (NNSH_FILEMODE_READONLY|NNSH_FILEMODE_TEMPFILE),
                        &fileRefR);
    if (ret != errNone)
    {
        Hide_BusyForm(false);
        NNsh_DebugMessage(ALTID_INFO, "Read File Open :", FILE_RECVMSG, ret);
        return (ret);
    }

    // ꎞobt@̈m
    realBuf = MemPtrNew(NNshParam->bufferSize + MARGIN);
    if (realBuf == NULL)
    {
        // ꎞ̈̊mۂɎs
        Hide_BusyForm(false);
        NNsh_InformMessage(ALTID_ERROR, MSG_MEMORY_ALLOC_FAIL, " size:",
                           NNshParam->bufferSize + MARGIN);
        CloseFile_NNsh(&fileRefR);
        return (~errNone);
    }
    buffer = realBuf;
    MemSet(buffer, (NNshParam->bufferSize + MARGIN), 0x00);

    // Ƀt@C݂ꍇ͈U폜ĂI[vB
    (void) DeleteFile_NNsh(targetFile, NNSH_VFS_ENABLE);
    ret = OpenFile_NNsh(targetFile,
                        NNSH_FILEMODE_APPEND, &fileRefW);
    if (ret != errNone)
    {
        // ݃t@C̃I[vɎs
        Hide_BusyForm(false);
        NNsh_InformMessage(ALTID_ERROR,
                           MSG_WRITEFILE_OPENFAIL, targetFile, ret);
        MemPtrFree(realBuf);
        CloseFile_NNsh(&fileRefR);
        return (ret);
    }

    // MbZ[WTCY擾
    GetFileSize_NNsh(&fileRefR, &fileSize);

    // f[^̓ǂݍ
    ret = ReadFile_NNsh(&fileRefR, offset,
                        NNshParam->bufferSize, buffer, &readSize);
    if ((ret != errNone)&&(ret != vfsErrFileEOF)&&(ret != fileErrEOF))
    {        
        NNsh_InformMessage(ALTID_ERROR, "ReadFile_NNsh :",  FILE_RECVMSG, ret);
        goto END_FUNC;
    }
    ret = errNone;

    // _E[h́At@C̍Ō׍H(ƎԂ邯)
    if (NNshParam->enablePartGet != 0)
    {
        while ((readSize != 0)&&
               (*((Char *) (buffer + readSize - 1)) != '\x0a'))
        {
            readSize--;
        }
        // IɎMt@CTCYbZ[W̍ŌɒB
        fileSize = readSize;
    }

    // HTTPwb_̏I
    ptr = StrStr(buffer, "\x0d\x0a\x0d\x0a");
    if (ptr == NULL)
    {
        // {fBf[^Ȃ
        NNsh_InformMessage(ALTID_ERROR, "ERR>Wrong data(not found separator,",
                           "[\xd\xa\xd\xa])", 0);
        ret = ~errNone + 3;
        goto END_FUNC;
    }

    // HTTP̉R[h`FbN(HTTP/1.[01] 20[06])
    //   StrLen("HTTP/1.1 200") ==> 12 ɒu(̂)
    if ((StrNCompare(buffer,"HTTP/1.1 200",12) != 0)&&
        (StrNCompare(buffer,"HTTP/1.1 206",12) != 0)&&
        (StrNCompare(buffer,"HTTP/1.0 206",12) != 0)&&
        (StrNCompare(buffer,"HTTP/1.0 200",12) != 0))
    {
#ifdef USE_STRSTR
        ptr = StrStr(buffer, "\x0a");
#else
        ptr = buffer;
        while ((*ptr != '\x0a')&&(*ptr != '\0'))
        {
            ptr++;
        }
#endif
        *ptr = '\0';
        if (*(ptr - 1) == '\x0d')
        {
            *(ptr - 1) = '\0';
        }
        // T[oX|Xُ
        NNsh_InformMessage(ALTID_ERROR, MSG_RECV_NOTACCEPTED, buffer, 0);
        ret = ~errNone + 10;
        goto END_FUNC;
    }
    ptr = ptr + 4;
    *dataSize = fileSize - (ptr - buffer);

    switch (bbsType)
    {
      case NNSH_BBSTYPE_MACHIBBS:
        //  ܂BBŜƂɂ́AbZ[W̐擪܂Ńf[^
        // ǂݔ΂s
        bakPtr = ptr;
        ptr = StrStr(ptr, NNSH_MACHITOKEN_START);
        if (ptr == NULL)
        {
            ptr = bakPtr;
        }
        break;

      case NNSH_BBSTYPE_SHITARABAJBBS:
#if 0
        // Ă񂾂ǁAAA擾̎Ɍ
        bakPtr = ptr;
        ptr = StrStr(ptr, NNSH_JBBSTOKEN_START);
        if (ptr == NULL)
        {
            ptr = bakPtr;
        }
#endif
        break;

      case NNSH_BBSTYPE_2ch:
      case NNSH_BBSTYPE_SHITARABA:
        // ȂɂȂ
        break;
    }

    // f[^݂̃`FbN(ނɒ)
    if (((UInt32) ptr & 1)&&(NNshParam->useVFS & NNSH_VFS_WORKAROUND))
    {
        ptr--;
        *ptr = ' ';
    }

    // f[^̏(ǋL)
    chkSize = readSize - (ptr - buffer);
    if (((chkSize % 2) == 1)&&(NNshParam->useVFS & NNSH_VFS_WORKAROUND))
    {
        if (ptr[chkSize - 1] == '\x0a')
        {
            ptr[chkSize]     = ptr[chkSize - 1];
            ptr[chkSize - 1] = ' ';
            NNsh_DebugMessage(ALTID_WARN, "APPEND SPACE(pre)", "", chkSize);
        }
        else
        {
            ptr[chkSize]     = ' ';
            NNsh_DebugMessage(ALTID_WARN, "APPEND SPACE(post)", "", chkSize);
        }
        chkSize++;
    }
    ret = AppendFile_NNsh(&fileRefW, chkSize, ptr ,&writeSize);
    if (ret != errNone)
    {
        NNsh_InformMessage(ALTID_ERROR, "WriteFile_NNsh(1st)", "", ret);
        deleteLogFile = true;
        *dataSize = 0;
        ret = ~errNone + 11;
        goto END_FUNC;
    }
    offset = readSize;

    // f[^ŌɂȂ܂ŒǋL
    while (offset < *dataSize)
    {
        MemSet(buffer, NNshParam->bufferSize + MARGIN, 0x00);
        readSize = 0;
        ret = ReadFile_NNsh(&fileRefR, offset, NNshParam->bufferSize,
                            buffer, &readSize);
        if ((ret != errNone)&&(ret != vfsErrFileEOF)&&(ret != fileErrEOF))
        {        
            NNsh_InformMessage(ALTID_ERROR, "ReadFile_NNsh()", "", ret);
            deleteLogFile = true;
            *dataSize = 0;
            break;
        }
        ret = errNone;
        chkSize = 0;
        if (((readSize % 2) == 1)&&(NNshParam->useVFS & NNSH_VFS_WORKAROUND))
        {
            if (ptr[readSize - 1] == '\x0a')
            {
                buffer[readSize]     = buffer[readSize - 1];
                buffer[readSize - 1] = ' ';
                NNsh_DebugMessage(ALTID_WARN, "APPEND spase(pre)", "",
                                  readSize);
            }
            else
            {
                buffer[readSize] = ' ';
                NNsh_DebugMessage(ALTID_WARN, "APPEND spase(post)",
                                  "", readSize);
            }
            chkSize++;
        }
        ret = AppendFile_NNsh(&fileRefW, readSize+chkSize, buffer, &writeSize);
        if (ret != errNone)
        {
            NNsh_InformMessage(ALTID_ERROR, "AppendFile_NNsh()", "", ret);
            deleteLogFile = true;
            *dataSize = 0;
            break;
        }
        offset = offset + readSize;
    }

END_FUNC:    
    CloseFile_NNsh(&fileRefR);
    CloseFile_NNsh(&fileRefW);
    if (realBuf != NULL)
    {
        MemPtrFree(realBuf);
    }
    if (deleteLogFile != false)
    {
        // r[ȃOt@CcĂƂɂ́At@C폜B
        (void) DeleteFile_NNsh(targetFile, NNSH_VFS_ENABLE);
    }
    Hide_BusyForm(false);

    return (ret);
}

/*-------------------------------------------------------------------------*/
/*   Function :   NNshMSG_appendMessage                                    */
/*                                            bZ[WϊAo^(ǋL) */
/*-------------------------------------------------------------------------*/
static Err message_appendMessage(Char *targetFile, NNshSubjectDatabase *mesDB)
{
    Err          ret;
    UInt32       fileSize, offset, readSize, writeSize, parseSize,chkSize;
    Char        *buffer, *ptr, *realBuf;
    NNshFileRef  fileRefR, fileRefW;

    // f[^o^\
    Show_BusyForm(MSG_MESSAGE_ENTRY);

    ret = OpenFile_NNsh(FILE_RECVMSG,
                        (NNSH_FILEMODE_READONLY|NNSH_FILEMODE_TEMPFILE),
                        &fileRefR);
    if (ret != errNone)
    {
        NNsh_DebugMessage(ALTID_INFO, "Read File Open :",FILE_RECVMSG, ret);
    }

    ret = OpenFile_NNsh(targetFile, NNSH_FILEMODE_APPEND, &fileRefW);
    if (ret != errNone)
    {
        NNsh_DebugMessage(ALTID_INFO, "Write File Open :", targetFile, ret);
    }

    // ꎞobt@̈m
    realBuf = MemPtrNew(NNshParam->bufferSize + MARGIN);
    if (realBuf == NULL)
    {
        NNsh_DebugMessage(ALTID_ERROR, "MemPtrNew()", " size:",
                          NNshParam->bufferSize + MARGIN);
        goto END_FUNC;
    }
    buffer = realBuf;

    // MbZ[W̃TCY擾(wb_)
    GetFileSize_NNsh(&fileRefR, &fileSize);
    parseSize = 0;
    readSize  = 0;
    offset    = 0;

    // f[^̓ǂݍ
    MemSet(buffer, NNshParam->bufferSize + MARGIN, 0x00);
    ret = ReadFile_NNsh(&fileRefR, offset, NNshParam->bufferSize,
                        buffer, &readSize);
    if ((ret != errNone)&&(ret != vfsErrFileEOF)&&(ret != fileErrEOF))
    {
        NNsh_InformMessage(ALTID_ERROR, "ReadFile_NNsh()", "", ret);

        goto END_FUNC;
    }

    // _E[h́At@C̍Ō׍H(ƎԂ邯)
    if (NNshParam->enablePartGet != 0)
    {
        while ((readSize != 0)&&
               (*((Char *) (buffer + readSize - 1)) != '\x0a'))
        {
            readSize--;
        }
        // IɎMt@CTCYbZ[W̍ŌɒB
        fileSize = readSize;
    }

    // HTTP{fB
    ptr = StrStr(buffer, "\x0d\x0a\x0d\x0a");
    if (ptr == NULL)
    {
        // f[^ُ
        NNsh_InformMessage(ALTID_ERROR, "ERR>Wrong data(not found separator,",
                           "(\x0d\x0a\x0d\x0a))", 0);
        goto END_FUNC;
    }
    parseSize = ptr - buffer;
    ptr       = ptr + 4;
    parseSize = parseSize + 4;

    // HTTP̉R[h`FbN
    // StrLen("HTTP/1.1 200") ==> 12 ɒu(̂)
    if ((StrNCompare(buffer,"HTTP/1.1 200 OK", 12) == 0)||
        (StrNCompare(buffer,"HTTP/1.0 200 OK", 12) == 0))
    {
        // Ȃ񂩒m񂯂ǁASbZ[Wł(ȁH)B
        CloseFile_NNsh(&fileRefR);
        CloseFile_NNsh(&fileRefW);
        if (realBuf != NULL)
        {
            MemPtrFree(realBuf);
        }
        Hide_BusyForm(false);

        // bZ[WׂĂłƂDEBUG\
        NNsh_DebugMessage(ALTID_INFO, "Received ALL MESSAGE!! ", 
                          targetFile, 0);

        // ׂẴf[^M鏈ɐ؂ւ
        ret = errNone;
        ret = message_entryMessage(targetFile, &fileSize, NNSH_BBSTYPE_2ch);
        mesDB->state      = NNSH_SUBJSTATUS_NEW;
        mesDB->fileSize   = fileSize;

        // X̋L^o^
        if ((NNshParam->useVFS & NNSH_VFS_ENABLE) != 0)
        {
            // XL^VFS
            mesDB->msgState = FILEMGR_STATE_OPENED_VFS;
        }
        else
        {    
            // XL^Palm{
            mesDB->msgState = FILEMGR_STATE_OPENED_STREAM;
        }
        return (ret);
    }

    if ((parseSize + 1 == readSize)&&(*ptr == '\x0a'))
    {
        // XXVȂ
        CloseFile_NNsh(&fileRefR);
        CloseFile_NNsh(&fileRefW);
        if (realBuf != NULL)
        {
            MemPtrFree(realBuf);
        }
        Hide_BusyForm(false);
        return (NNSH_MSGSTATE_NOTMODIFIED);
    }
    if (*ptr != '\x0a')
    {
        // f[^G[H(G[̏ڍׂ͖`FbN)
        CloseFile_NNsh(&fileRefR);
        CloseFile_NNsh(&fileRefW);
        if (realBuf != NULL)
        {
            MemPtrFree(realBuf);
        }
        Hide_BusyForm(false);

        return (NNSH_MSGSTATE_ERROR);
    }
    // XV`FbNp̕(1oCg)߂B
    ptr++;
    parseSize++;
    fileSize = fileSize - (ptr - buffer);

    if (((UInt32) ptr & 1)&&(NNshParam->useVFS & NNSH_VFS_WORKAROUND))
    {
        ptr--;
        *ptr = ' ';
    }
     // f[^̏(ǋL)
    chkSize  = readSize - (ptr - buffer);
    if (((chkSize % 2) == 1)&&(NNshParam->useVFS & NNSH_VFS_WORKAROUND))
    {
        //  Ō̕LڂȂ̂ł͂ȂAŌ̑̕Oɋ󔒂}
        // ƂŁA݃oCgɂB(v0.80r003) łH
        if (ptr[chkSize - 1] == '\x0a')
        {
            ptr[chkSize]     = ptr[chkSize - 1];
            ptr[chkSize - 1] = ' ';
            NNsh_DebugMessage(ALTID_WARN, "append spc(pre)", "", chkSize);
        }
        else
        {
            buffer[chkSize] = ' ';
            NNsh_DebugMessage(ALTID_WARN, "append spc(post)", "", chkSize);
        }
        chkSize++;
    }
    ret = AppendFile_NNsh(&fileRefW, chkSize, ptr, &writeSize);
    if (ret != errNone)
    {
        NNsh_InformMessage(ALTID_ERROR, "WRITEFile_NNsh(1st)", "", ret);
        goto END_FUNC;
    }
    offset = readSize;

    while (offset < fileSize)
    {
        MemSet(buffer, NNshParam->bufferSize + MARGIN, 0x00);
        readSize = 0;
        ret = ReadFile_NNsh(&fileRefR, offset, NNshParam->bufferSize,
                            buffer, &readSize);
        if ((ret != errNone)&&(ret != vfsErrFileEOF)&&(ret != fileErrEOF))
        {        
            NNsh_InformMessage(ALTID_ERROR, "ERR>ReadFile_NNsh", "", ret);
            break;
        }
        chkSize = 0;
        if (((readSize % 2) == 1)&&(NNshParam->useVFS & NNSH_VFS_WORKAROUND))
        {
            if (ptr[readSize - 1] == '\x0a')
            {
                buffer[readSize]     = buffer[readSize - 1];
                buffer[readSize - 1] = ' ';
                NNsh_DebugMessage(ALTID_WARN, "Append space(pre)", "",
                                  readSize);
            }
            else
            {
                buffer[readSize] = ' ';
                NNsh_DebugMessage(ALTID_WARN, "Append space(post)", "",
                                  readSize);
            }
            chkSize++;
        }
        ret = AppendFile_NNsh(&fileRefW, readSize+chkSize, buffer, &writeSize);
        if (ret != errNone)
        {
            NNsh_InformMessage(ALTID_ERROR, "ERR>WriteFile_NNsh()", "", ret);
            break;
        }
        offset = offset + readSize;
    }
    mesDB->fileSize = mesDB->fileSize + fileSize;
    if (fileSize != 0)
    {
        // update
        mesDB->state = NNSH_SUBJSTATUS_UPDATE;

        // X̋L^o^
        if ((NNshParam->useVFS & NNSH_VFS_ENABLE) != 0)
        {
            // XL^VFS
            mesDB->msgState = FILEMGR_STATE_OPENED_VFS;
        }
        else
        {    
            // XL^Palm{
            mesDB->msgState = FILEMGR_STATE_OPENED_STREAM;
        }
    }

END_FUNC:    
    CloseFile_NNsh(&fileRefR);
    CloseFile_NNsh(&fileRefW);
    if (realBuf != NULL)
    {
        MemPtrFree(realBuf);
    }
    Hide_BusyForm(false);

    return (errNone);
}

/*=========================================================================*/
/*   Function :   Get_AllMessage                                           */
/*                                                        bZ[WS擾 */
/*=========================================================================*/
Err Get_AllMessage(Char *url, Char *boardNick, Char *file, UInt16 idxMES,
                   UInt16 bbsType)
{
    Err                  ret;
    UInt32               fileSize, range;
    Char                 fileName[MAXLENGTH_FILENAME];

    // bZ[Wi[t@C쐬
    MemSet (fileName, sizeof(fileName), 0x00);
    StrCopy(fileName, boardNick);
    StrCat (fileName, file);

    // _E[hw莞ɂ̓Wݒs
    if (NNshParam->enablePartGet != 0)
    {
        range = (UInt32) NNshParam->partGetSize - NNSH_HTTPGET_HEADERMAX;
    }
    else
    {
        range = HTTP_RANGE_OMIT;
    }

    // bZ[WM
    ret = NNshHttp_comm(HTTP_SENDTYPE_GET, url, NULL, NULL,
                        HTTP_GETSUBJECT_START, range, NULL);
    if (ret != errNone)
    {
        // ʐMG[
        if (ret == netErrTimeout)
        {
            NNsh_InformMessage(ALTID_ERROR, MSG_OCCUR_TIMEOUT, "", ret);
        }
        else
        {
            NNsh_InformMessage(ALTID_ERROR, MSG_ERROR_HTTP_COMM, "", ret);
        }
        return (ret);
    }

    // Mf[^ϊAo^B
    ret = message_entryMessage (fileName, &fileSize, bbsType);
    message_entryDatabase(idxMES, fileSize, bbsType);

    return (ret);
}

/*=========================================================================*/
/*   Function :   Get_PartMessage                                          */
/*                                                      bZ[W擾 */
/*=========================================================================*/
Err Get_PartMessage(Char *url, Char *boardNick, NNshSubjectDatabase *mesDB, 
                    UInt16 idxMES, Char *message)
{
    Err    ret, ret1;
    Char   fileName[MAXLENGTH_FILENAME];
    UInt32 range;

    // bZ[Wi[t@C쐬
    MemSet (fileName, sizeof(fileName), 0x00);
    StrCopy(fileName, boardNick);
    StrCat (fileName, mesDB->threadFileName);

    // _E[hw莞ɂ̓Wݒs
    if (NNshParam->enablePartGet != 0)
    {
        range = (UInt32) NNshParam->partGetSize - 
                         NNSH_HTTPGET_HEADERMAX + (mesDB->fileSize - 1);
    }
    else
    {
        range = HTTP_RANGE_OMIT;
    }
    // bZ[W𑗎M
    ret = NNshHttp_comm(HTTP_SENDTYPE_GET, url, NULL, NULL,
                        (mesDB->fileSize - 1), range, message);
    if (ret != errNone)
    {
        // ʐMG[
        if (ret == netErrTimeout)
        {
            NNsh_InformMessage(ALTID_ERROR, MSG_OCCUR_TIMEOUT, "", ret);
        }
        else
        {
            NNsh_InformMessage(ALTID_ERROR, MSG_ERROR_HTTP_COMM, "", ret);
        }
        return (ret);
    }

    // Mf[^ϊAo^B
    ret1 = message_appendMessage(fileName, mesDB);
    switch (ret1)
    {
      case errNone:
        // f[^ϊAւށB
        break;

      case NNSH_MSGSTATE_NOTMODIFIED:
        // f[^XV
        NNsh_InformMessage(ALTID_INFO, 
                           MSG_RECV_NOTMODIFY, mesDB->threadTitle, 0);
        goto FUNC_END;
        break;

      case NNSH_MSGSTATE_ERROR:
        // f[^Ms
        NNsh_InformMessage(ALTID_ERROR, 
                          MSG_RECV_PARTMSG_ERROR, mesDB->threadTitle, ret);
        // mesDB->state        = NNSH_SUBJSTATUS_UNKNOWN;

        // XɃG[ݒ肷(擾\XNA)
        mesDB->msgAttribute = (mesDB->msgAttribute | NNSH_MSGATTR_ERROR);
        mesDB->msgAttribute = (mesDB->msgAttribute & NNSH_MSGATTR_NOTRESERVE);
        (void) update_subject_database(idxMES, mesDB);
        return (~errNone - 12);
        break;

      default:
        break;
    }
FUNC_END:
    // X̃G[NA
    mesDB->msgAttribute = ((mesDB->msgAttribute)&
                           (NNSH_MSGATTR_NOTERROR)&(NNSH_MSGATTR_NOTRESERVE));

    // XbZ[Wf[^x[X̓eXVB
    ret = update_subject_database(idxMES, mesDB);
    if (ret != errNone)
    {
        // 肦Ȃ͂...
        NNsh_DebugMessage(ALTID_INFO, "update_subject_database()"," ", ret);
    }
    return (ret1);
}

/*=========================================================================*/
/*   Function : MoveSubject_BBS                                            */
/*                                              X̏ύX */
/*=========================================================================*/
Err MoveSubject_BBS(Char *dest, Char *src)
{
    Err                 ret;
    UInt16              index, cnt;
    DmOpenRef           dbRef;
    NNshSubjectDatabase subjDB;

    // XǗDBI[v
    OpenDatabase_NNsh(DBNAME_SUBJECT, DBVERSION_SUBJECT, &dbRef);
    if (dbRef == 0)
    {
        // G[(fobO\)
        NNsh_DebugMessage(ALTID_ERROR, "OpenDatabase_NNsh() ", " ", 0);
        return (~errNone);
    }
    GetDBCount_NNsh(dbRef, &cnt);
    for (index = 0; index < cnt; cnt++)
    {
        // Xf[^擾
        ret = GetRecord_NNsh(dbRef, index,
                             sizeof(NNshSubjectDatabase), &subjDB);
        if (ret != errNone)
        {
            // G[(fobO\)
            NNsh_DebugMessage(ALTID_ERROR, "GetRecord_NNsh() ", " ", ret);
            continue;
        }

        // w肵{[hjbNl[`FbN
        if (StrCompare(subjDB.boardNick, src) == 0)
        {
            // Xړ
            MemSet (subjDB.boardNick, MAX_NICKNAME, 0x00);
            StrCopy(subjDB.boardNick, dest);
            UpdateRecord_NNsh(dbRef, index,
                              sizeof(NNshSubjectDatabase), &subjDB);
        }
    }
    CloseDatabase_NNsh(dbRef);

    // XꗗDBXVƂɂ
    NNshGlobal->updateDatabaseInfo = 
                ((NNshGlobal->updateDatabaseInfo) | (NNSH_DB_UPDATE_SUBJECT));


    return (errNone);
}

/*=========================================================================*/
/*   Function : MarkMessageIndex                                           */
/*                                           bZ[Wǂݏo󋵂ݒ  */
/*=========================================================================*/
void MarkMessageIndex(UInt16 index, UInt16 favor)
{
    Err                  ret;
    NNshSubjectDatabase  subjDB;

    ret = Get_Subject_Database(index, &subjDB);
    if (ret == errNone)
    {
        if ((NNshGlobal->msgIndex) != NULL)
        {
            subjDB.currentLoc = (NNshGlobal->msgIndex)->openMsg;
            subjDB.maxLoc     = (NNshGlobal->msgIndex)->nofMsg;    
            if ((NNshGlobal->msgIndex)->nofMsg == 
                                             (NNshGlobal->msgIndex)->openMsg)
            {
                subjDB.state = NNSH_SUBJSTATUS_ALREADY;
            }
            else
            {
                subjDB.state = NNSH_SUBJSTATUS_REMAIN;
            }

            // MSG̏ꏊsꍇɂ́AL^LB
            if ((subjDB.msgState == 0)&&
                (subjDB.maxLoc != 0)&&(subjDB.currentLoc != 0))
            {
                if ((NNshParam->useVFS & NNSH_VFS_ENABLE) != 0)
                {
                    // XL^VFS
                    subjDB.msgState = FILEMGR_STATE_OPENED_VFS;
                }
                else
                {    
                    // XL^Palm{
                    subjDB.msgState = FILEMGR_STATE_OPENED_STREAM;
                }
            }
        }
        switch (favor)
        {
          case NNSH_MSGATTR_NOTSPECIFY:
            // Cɓݒ͕ύXȂ
            break;
          case 0:
            // CɓݒNA
            subjDB.msgAttribute 
                               = (subjDB.msgAttribute & NNSH_MSGATTR_NOTFAVOR);
            break;
          default:
            // w肳ꂽCɓݒs
            subjDB.msgAttribute 
                  = ((subjDB.msgAttribute & NNSH_MSGATTR_NOTFAVOR)| favor);
            break;
        }

        (void) update_subject_database(index, &subjDB);
    }
    return;
}

/*=========================================================================*/
/*   Function :   Get_MessageFromMesNum                                    */
/*                                            Xԍw̃bZ[W擾 */
/*=========================================================================*/
Boolean Get_MessageFromMesNum(Boolean *updateBBS)
{
    Boolean              rep = false;
    Err                  ret;
    UInt16               btnId, index, dataIndex;
    UInt32               size;
    DmOpenRef            dbRef;
    Char                *url, *ptr, *nPtr;
    NNshBoardDatabase   bbsData;
    NNshSubjectDatabase subjDb;

    // [Nobt@̊mۂƏ
    url     = MemPtrNew(BUFSIZE);
    if (url == NULL)
    {
        return (false);
    }
    index = 0;
    MemSet(&subjDb,  sizeof(NNshSubjectDatabase), 0x00);
    MemSet(&bbsData, sizeof(NNshBoardDatabase),   0x00);
    MemSet(url,     BUFSIZE,                      0x00);
    *updateBBS = false;

    // ͕̎擾
    rep = DataInputDialog(NNSH_INPUTWIN_GETMESNUM,
                          url, BUFSIZE,
                          NNSH_DIALOG_USE_GETMESNUM, NULL);
    if (rep == false)
    {
        // 񂪓͂ȂAI
        MEMFREE_PTR(url);
        return (false);
    }

    // ̓f[^Nick؂o
    ptr  = url;
    nPtr = subjDb.boardNick;
    while (*ptr != '/')
    { 
        *nPtr = *ptr;
        ptr++;
        nPtr++;
        if (*ptr == '\0')
        {
            // f[^擾G[AI
            NNsh_InformMessage(ALTID_ERROR, MSG_ERROR_GETFAILURE, "", 0);
            rep = false;
            goto FUNC_END;
        }
    }
    *nPtr = '/';    // Nick̍Ō '/'tĂ

    // Xԍ؂o
    ptr++;
    nPtr = subjDb.threadFileName;
    while ((*ptr != '/')&&(*ptr != '\0'))
    {
        *nPtr = *ptr;
	nPtr++;
        ptr++;
    }

    // BBSꗗǂݍݒ̃bZ[W\
    Show_BusyForm(MSG_READ_BBSLIST_WAIT);

    // ̎擾
    ret = Get_BBS_Database(subjDb.boardNick, &bbsData, &index);
    if (ret != errNone)
    {
        // 擾ɎsAG[\ďI
        NNsh_ErrorMessage(ALTID_ERROR, subjDb.boardNick,
                          MSG_WRONG_BOARDNICK, ret);
        Hide_BusyForm(false);
        rep = false;
        goto FUNC_END;
    }

    // bZ[W̋L
    MemSet (url, BUFSIZE, 0x00);
    StrCopy(url, bbsData.boardName);
    StrCat (url, MSG_CONFIRM_GETTHREAD);
    StrCat (url, subjDb.threadFileName);
    StrCat (url, ")");

    // bZ[W̍폜
    Hide_BusyForm(false);

    // {ɃX擾邩mFs
    btnId = NNsh_ConfirmMessage(ALTID_CONFIRM, url, "", 0);
    if (btnId != 0)
    {
        // 擾LZ
        NNsh_InformMessage(ALTID_INFO, MSG_ABORT_INFO, "", 0);
        rep = false;
        goto FUNC_END;
    }

    // bZ[W擾̍쐬
    MemSet (url, BUFSIZE, 0x00);
    StrCopy(url, bbsData.boardURL);
    switch (bbsData.bbsType)
    {
      case NNSH_BBSTYPE_MACHIBBS:
        // ܂BBSf[^擾(HTMLǂ)
        StrCat (url, URL_PREFIX_MACHIBBS);
        StrCat (url, bbsData.boardNick);
        // boardNick̖ɂ '/'폜
        if (url[StrLen(url) - 1] == '/')
        {
            url[StrLen(url) - 1] = '\0';
        } 
        StrCat (url, "&KEY=");
        StrCat (url, subjDb.threadFileName);

        StrCat (subjDb.threadFileName, ".cgi");   // gq

        //////////////////////////////////////////////////////////////////////
        // ݁A܂aarɂ͂̋@\͎gpłȂ|\ďIB
        NNsh_InformMessage(ALTID_WARN, MSG_NOTSUPPORT_MACHI,"",0);
        rep = false;
        goto FUNC_END;
        //////////////////////////////////////////////////////////////////////
        break;

      case NNSH_BBSTYPE_SHITARABAJBBS:
        // ΁JBBSf[^擾(HTMLǂ)
        StrCat (url, URL_PREFIX_SHITARABAJBBS);
        StrCat (url, bbsData.boardNick);
        // boardNick̖ɂ '/'폜
        if (url[StrLen(url) - 1] == '/')
        {
            url[StrLen(url) - 1] = '\0';
        } 
        StrCat (url, "&KEY=");
        StrCat (url, subjDb.threadFileName);

        StrCat (subjDb.threadFileName, ".cgi");   // gq

        //////////////////////////////////////////////////////////////////////
        // ݁A̋@\͎gpłȂ|\ďIB
        NNsh_InformMessage(ALTID_WARN, MSG_NOTSUPPORT_BBS,"",0);
        rep = false;
        goto FUNC_END;
        //////////////////////////////////////////////////////////////////////
        break;

      case NNSH_BBSTYPE_SHITARABA:
      case NNSH_BBSTYPE_2ch:
      default:
        // 2chf[^擾(datǂ)
        StrCat (subjDb.threadFileName, ".dat");   // gq

        StrCat (url, "dat/");
        StrCat (url, subjDb.threadFileName);
        break;
    }

    // Xf[^擾ς݂mFB
    if (Check_same_thread(NNSH_NOTENTRY_THREAD, &subjDb, &subjDb, &dataIndex)
                                                                    == errNone)
    {
        // 擾ς݂ƔA擾ɐ؂ւ
        ret = Get_PartMessage(url,bbsData.boardNick,&subjDb,dataIndex,NULL);

        // 擾I̕\(DEBUGIvVL̂)
        NNsh_InformMessage(ALTID_INFO, MSG_GET_PARTMESSAGE_END,
                           subjDb.threadTitle, ret);
        rep = (ret == errNone) ? true : false;
        goto FUNC_END;
    }

    ////////////  bZ[WS擾̏  ///////////

    // X擾̃bZ[W\
    Show_BusyForm(MSG_MESSAGE_INFO_WAIT);

    /////////////////////////////////////////////////////////////////////////
    // f[^x[XɃXf[^()ǉ X^Cg͌Œǉ遦
    /////////////////////////////////////////////////////////////////////////
    StrCopy(subjDb.threadTitle, "(Unknown)");

    OpenDatabase_NNsh(DBNAME_SUBJECT, DBVERSION_SUBJECT, &dbRef);
    if (dbRef == 0)
    {
        // bZ[W̍폜
        Hide_BusyForm(false);

        // G[
        NNsh_DebugMessage(ALTID_ERROR, "OpenDatabase_NNsh()", "", 0);
        rep = false;
        goto FUNC_END;
    }
    EntryRecord_NNsh(dbRef, sizeof(NNshSubjectDatabase), &subjDb);
    CloseDatabase_NNsh(dbRef);

    // XꗗDBXVƂɂ
    NNshGlobal->updateDatabaseInfo = 
                ((NNshGlobal->updateDatabaseInfo) | (NNSH_DB_UPDATE_SUBJECT));

    /** (VFS)fBNg쐬 **/
    (void) CreateDir_NNsh(bbsData.boardNick);
    
    // bZ[W̍폜
    Hide_BusyForm(false);

    // O擾ыL^
    ret = Get_AllMessage(url, bbsData.boardNick, subjDb.threadFileName,
                         0, (UInt16) bbsData.bbsType);

    if (ret != errNone)
    {
        // Xt@C ϐurlɏoA(O)Xt@C폜
        MemSet (url, BUFSIZE, 0x00);
        StrCopy(url, bbsData.boardNick);
        StrCat (url, subjDb.threadFileName);
        if ((NNshParam->useVFS & NNSH_VFS_ENABLE) == 0)
        {
            // Palm{̏̃O폜
            ret = DeleteFile_NNsh(url, NNSH_VFS_DISABLE);
        }
        else
        {
            // VFS̃O폜
            ret = DeleteFile_NNsh(url, NNSH_VFS_ENABLE);
        }

        // G[(ǉf[^x[Xf[^폜)
        (void) OpenDatabase_NNsh(DBNAME_SUBJECT, DBVERSION_SUBJECT, &dbRef);
        DeleteRecordIDX_NNsh(dbRef, 0);
        CloseDatabase_NNsh(dbRef);
        NNsh_DebugMessage(ALTID_ERROR, "Get_AllMessage()", "", ret);
        rep = false;
        goto FUNC_END;
    }

    //////////////////X^Cg擾/////////////////////////

    // X擾̃bZ[W\
    Show_BusyForm(MSG_MESSAGE_INFO_WAIT);

    // X擾
    (void) Get_Subject_Database(0, &subjDb);

    // t@CTCYꎞIɋL
    size = subjDb.fileSize;

    // Xt@C ϐurlɏo
    MemSet (url, BUFSIZE, 0x00);
    StrCopy(url, bbsData.boardNick);
    StrCat (url, subjDb.threadFileName);

    // t@CX擾
    ret = SetThreadInformation(url, (NNSH_FILEMODE_READONLY), &subjDb);
    if (ret != errNone)
    {
        // G[
        NNsh_DebugMessage(ALTID_ERROR, "SetThreadInformation()\nFileName:",
                          subjDb.threadFileName, ret);
        // ^[ɏp
    }

    // t@CTCY߂
    subjDb.fileSize = size;

    // R[h̓o^
    ret = update_subject_database(0, &subjDb);

    // bZ[W̍폜
    Hide_BusyForm(false);

    if (ret != errNone)
    {
        // G[
        NNsh_DebugMessage(ALTID_ERROR, "update_subject_database()", "", ret);
        rep = false;
        goto FUNC_END;
    }

    // 擾I̕\
    NNsh_InformMessage(ALTID_INFO,MSG_GET_MESSAGE_END,subjDb.threadTitle,ret);

    if (bbsData.state != NNSH_BBSSTATE_VISIBLE)
    {
        // BBSgpݒɂčXV
        bbsData.state     = NNSH_BBSSTATE_VISIBLE;

        // BBS̍XV
        Update_BBS_Database(index, &bbsData);

        *updateBBS = true;

        // gpBBSꗗǉꂽƂʒm
        NNsh_InformMessage(ALTID_WARN,bbsData.boardName,MSG_WARN_BBSUPDATE,0);
    }
    rep = true;

FUNC_END:
    // ֐̏IA
    MEMFREE_PTR(url);
    return (rep);
}


/*=========================================================================*/
/*   Function :   Hander_MessageInfo                                       */
/*                                 bZ[W񑀍쎞̃Cxgnh  */
/*=========================================================================*/
Boolean Handler_MessageInfo(EventType *event)
{
    // ݂̃tH[擾
    switch (event->eType)
    { 
      case menuEvent:
        break;

      case ctlSelectEvent:
        break;

      default: 
        break;
    }
    return (false);
}

/*=========================================================================*/
/*   Function : DisplayMessageInformations                                 */
/*                                                     X\  */
/*=========================================================================*/
Err DisplayMessageInformations(UInt16 msgIndex, UInt16 *msgAttribute)
{
    Err                 ret;
    Char                logBuf[BIGBUF], *ptr, *urlTop;
    UInt16              index, btnId, status;
    FormType           *prevFrm, *diagFrm;
    NNshSubjectDatabase mesInfo;
    NNshBoardDatabase   bbsInfo;

    // bZ[Wf[^x[X擾
    ret = Get_Subject_Database(msgIndex, &mesInfo);
    if (ret != errNone)
    {
        // G[(fobO\)
        NNsh_DebugMessage(ALTID_ERROR, "get_subject_database()", "", ret);
        return (ret);
    }

    // BBSf[^x[X擾
    ret = Get_BBS_Database(mesInfo.boardNick, &bbsInfo, &index);
    if (ret != errNone)
    {
        // G[(fobO\)
        NNsh_DebugMessage(ALTID_ERROR, "Get_BBS_Database() nick:", 
                          mesInfo.boardNick, ret);
        return (ret);
    }

    /////////////////// XbZ[W\z  ///////////////////////

    // ݂̉ʃ|C^擾
    prevFrm = FrmGetActiveForm();

    // PalmOS v3.5ȉȂAÕtH[B
    if (NNshGlobal->palmOSVersion < 0x03503000)
    {
        FrmEraseForm(prevFrm);
    }

    // XʂJ
    diagFrm  = FrmInitForm(FRMID_MESSAGEINFO);
    if (diagFrm != NULL)
    {
        // tH[ANeBuɂ
        FrmSetActiveForm(diagFrm);

        // Cxgnh̐ݒ
        FrmSetEventHandler(diagFrm, Handler_MessageInfo);

        // bZ[W̐
        MemSet (logBuf, sizeof(logBuf), 0x00);
        StrCat (logBuf, NNSH_MSGINFO_MSGNUM);
        NUMCATI(logBuf, mesInfo.currentLoc);
        StrCat (logBuf, "/");
        NUMCATI(logBuf, mesInfo.maxLoc);

        // bZ[W̕\
        NNshWinSetFieldText(diagFrm,FLDID_MSGSTATUS,false,logBuf,StrLen(logBuf));

        // t@C̍쐬
        MemSet (logBuf, sizeof(logBuf), 0x00);
        StrCopy(logBuf, NNSH_MSGINFO_FILELOC);

        // bZ[W̋L^ӏo͂
        switch (mesInfo.msgState)
        {
          case FILEMGR_STATE_OPENED_VFS:
            StrCat(logBuf, "VFS (");
            break;
          case FILEMGR_STATE_OPENED_STREAM:
            StrCat(logBuf, "Palm (");
            break;
          default:
            StrCat(logBuf, "??? (");
            break;
        }
        NUMCATI(logBuf, mesInfo.fileSize);
        StrCat (logBuf, " bytes)");

        // t@C̕\
        NNshWinSetFieldText(diagFrm,FLDID_FILESTATUS,false,logBuf,StrLen(logBuf));

        // ̑̍쐬
        MemSet (logBuf, sizeof(logBuf), 0x00);
        StrCopy(logBuf, NNSH_MSGINFO_STATUS);
        switch(mesInfo.state)
        {
          case NNSH_SUBJSTATUS_NOT_YET:
            // 擾
            StrCat(logBuf, NNSH_SUBJSTATUSMSG_NOT_YET);
            break;
          case NNSH_SUBJSTATUS_NEW:
            // VK擾
            StrCat(logBuf, NNSH_SUBJSTATUSMSG_NEW);
            break;
          case NNSH_SUBJSTATUS_UPDATE:
            // XV擾
            StrCat(logBuf, NNSH_SUBJSTATUSMSG_UPDATE);
            break;
          case NNSH_SUBJSTATUS_REMAIN:
            // ǂ
            StrCat(logBuf, NNSH_SUBJSTATUSMSG_REMAIN);
            break;
          case NNSH_SUBJSTATUS_ALREADY:
            // 
            StrCat(logBuf, NNSH_SUBJSTATUSMSG_ALREADY);
            break;
          case NNSH_SUBJSTATUS_UNKNOWN:
          default:
            // ԕs
            StrCat(logBuf, NNSH_SUBJSTATUSMSG_UNKNOWN);
            break;
        }
        if ((mesInfo.msgAttribute & NNSH_MSGATTR_ERROR) != 0)
        {
            // MG[\
            StrCat(logBuf, NNSH_MSGINFO_RECVERR);
        }

        // ̑(bZ[W擾)̕\
        NNshWinSetFieldText(diagFrm, FLDID_ETCSTATUS,
                            false, logBuf, StrLen(logBuf));

        // X^Cg̐ݒ
        // (̃^CgɋLURLėp邽߁A\ԂύX)
        MemSet (logBuf, sizeof(logBuf), 0x00);
        StrCopy(logBuf, mesInfo.threadTitle);
        StrCat (logBuf, "\n");

        // XURL̐擪|C^L
        urlTop = &logBuf[StrLen(logBuf)];

        // XURL
        switch (bbsInfo.bbsType)
        {
          case NNSH_BBSTYPE_MACHIBBS:
            // ܂aar̂tqko͂
            StrCat (logBuf, bbsInfo.boardURL);
            if (NNshParam->useImodeURL == 0)
            {
                StrCat (logBuf, URL_PREFIX_MACHIBBS);
            }
            else
            {
                StrCat (logBuf, URL_PREFIX_MACHIBBS_IMODE);
            }
            StrCat (logBuf, mesInfo.boardNick);
            // boardNick̖ɂ '/'폜
            if (logBuf[StrLen(logBuf) - 1] == '/')
            {
                logBuf[StrLen(logBuf) - 1] = '\0';
            } 
            StrCat (logBuf, "&KEY=");
            StrCat (logBuf, mesInfo.threadFileName);
            break;

          case NNSH_BBSTYPE_SHITARABAJBBS:
            // ΁iaar̂tqko͂
            StrCat (logBuf, bbsInfo.boardURL);
            if (NNshParam->useImodeURL == 0)
            {
                StrCat (logBuf, URL_PREFIX_SHITARABAJBBS);
            }
            else
            {
                StrCat (logBuf, URL_PREFIX_SHITARABAJBBS_IMODE);
            }
            StrCat (logBuf, mesInfo.boardNick);
            // boardNick̖ɂ '/'폜
            if (logBuf[StrLen(logBuf) - 1] == '/')
            {
                logBuf[StrLen(logBuf) - 1] = '\0';
            } 
            StrCat (logBuf, "&KEY=");
            StrCat (logBuf, mesInfo.threadFileName);
            break;

          case NNSH_BBSTYPE_SHITARABA:
            // ΂̂tqko͂
            StrCat (logBuf, bbsInfo.boardURL);
            if (NNshParam->useImodeURL == 0)
            {
                StrCat (logBuf, URL_PREFIX_SHITARABA);
            }
            else
            {
                StrCat (logBuf, URL_PREFIX_SHITARABA_IMODE);
            }
            StrCat (logBuf, mesInfo.boardNick);
            // boardNick̖ɂ '/'폜
            if (logBuf[StrLen(logBuf) - 1] == '/')
            {
                logBuf[StrLen(logBuf) - 1] = '\0';
            } 
            StrCat (logBuf, "&key=");
            StrCat (logBuf, mesInfo.threadFileName);
            break;

          case NNSH_BBSTYPE_2ch:
          default: 
           // 2cĥtqko͂
            StrCat (logBuf, bbsInfo.boardURL);

            // 2chURLɂ́A{[h܂܂Ă̂ŁA̕B
            ptr = logBuf + StrLen(logBuf) - 2;
            while (*ptr != '/')
            {
                ptr--;
            }
            *ptr = '\0';
            StrCat (logBuf, "/");
            if (NNshParam->useImodeURL == 0)
            {
                StrCat (logBuf, URL_PREFIX);
            }
            else
            {
                StrCat (logBuf, URL_PREFIX_IMODE);
            }
            StrCat (logBuf, bbsInfo.boardNick);
            StrCat (logBuf, mesInfo.threadFileName);
            break;
        }

        // ".dat"  ".cgi " ͍폜
        ptr = logBuf + StrLen(logBuf) - 1;
        while (*ptr != '.')
        {
            ptr--;
        }
        *ptr = '\0';

        // XURL̐ݒ
        NNshWinSetFieldText(diagFrm,FLDID_MSGURL,true,logBuf,StrLen(logBuf));

        // ݂̃XCɓ背xݒ
        status = 1;
        switch(mesInfo.msgAttribute & NNSH_MSGATTR_FAVOR)
        {
          case NNSH_MSGATTR_FAVOR_L1:
            // Cɓ背x()
            SetControlValue(diagFrm, PBTNID_FAVOR_L1, &status);
            break;

          case NNSH_MSGATTR_FAVOR_L2:
            // Cɓ背x()
            SetControlValue(diagFrm, PBTNID_FAVOR_L2, &status);
            break;

          case NNSH_MSGATTR_FAVOR_L3:
            // Cɓ背x()
            SetControlValue(diagFrm, PBTNID_FAVOR_L3, &status);
            break;

          case NNSH_MSGATTR_FAVOR_L4:
            // Cɓ背x()
            SetControlValue(diagFrm, PBTNID_FAVOR_L4, &status);
            break;

          case NNSH_MSGATTR_FAVOR:
            // Cɓ背x()
            SetControlValue(diagFrm, PBTNID_FAVOR_L5, &status);
            break;

          default:
            // Cɓł͂Ȃ
            SetControlValue(diagFrm, PBTNID_FAVOR_L0, &status);
            break;
        }

        // _CAOI[v
        btnId = FrmDoDialog(diagFrm);

        // Xx̐ݒ茋ʊmF
        status = 0;
        UpdateParameter(diagFrm, PBTNID_FAVOR_L0, &status);
        if (status != 0)
        {
            // Cɓݒ肳ĂȂ
            *msgAttribute = 0;
            goto DELETE_DIALOG;
        }
        UpdateParameter(diagFrm, PBTNID_FAVOR_L1, &status);
        if (status != 0)
        {
            // Cɓݒ()
            *msgAttribute = NNSH_MSGATTR_FAVOR_L1;
            goto DELETE_DIALOG;
        }
        UpdateParameter(diagFrm, PBTNID_FAVOR_L2, &status);
        if (status != 0)
        {
            // Cɓݒ()
            *msgAttribute = NNSH_MSGATTR_FAVOR_L2;
            goto DELETE_DIALOG;
        }
        UpdateParameter(diagFrm, PBTNID_FAVOR_L3, &status);
        if (status != 0)
        {
            // Cɓݒ()
            *msgAttribute = NNSH_MSGATTR_FAVOR_L3;
            goto DELETE_DIALOG;
        }
        UpdateParameter(diagFrm, PBTNID_FAVOR_L4, &status);
        if (status != 0)
        {
            // Cɓݒ()
            *msgAttribute = NNSH_MSGATTR_FAVOR_L4;
            goto DELETE_DIALOG;
        }
        UpdateParameter(diagFrm, PBTNID_FAVOR_L5, &status);
        if (status != 0)
        {
            // Cɓݒ()
            *msgAttribute = NNSH_MSGATTR_FAVOR;
            goto DELETE_DIALOG;
        }

DELETE_DIALOG:
        // _CAO
        FrmSetActiveForm(prevFrm);
        FrmDeleteForm(diagFrm);

        if (btnId == BTNID_OPEN_BROWSER)
        {
            // uuEUŊJv{^ꂽƂ

            // Cɓݒɂ(f[^x[X)XV
            MarkMessageIndex(msgIndex, *msgAttribute);

            // WebuEUCXg[Ă邩mF
            if (NNshGlobal->browserCreator == 0)
            {
                // installĂȂƂ"T|[gĂ܂" \s
                NNsh_InformMessage(ALTID_ERROR, MSG_NOT_SUPPORT, "", 0);
                return (errNone);
            }

            // WebuEUŊJmF
            if (NNsh_ConfirmMessage(ALTID_CONFIRM, urlTop,
                                    MSG_WEBLAUNCH_CONFIRM, 0) == 0)
            {
                // Web BrowserN(NNsiIɋN)
                (void) WebBrowserCommand(NNshGlobal->browserCreator,
                                         false, 0, 
                                         NNshGlobal->browserLaunchCode,
                                         urlTop, NULL);
            }
            return (errNone);
        }        
    }

    // Cɓݒɂ(f[^x[X)XV
    MarkMessageIndex(msgIndex, *msgAttribute);
    return (errNone);
}
